package kripos.geo;

import jade.core.AID;

/**
 * Utility class that bundles AID and Case information. 
 * For use by AdminAgents to keep track of which GWAgent requested which Case
 *
 * @author oysteine
 * @version 1.0
 */
public class GWCase {
  private AID myAID;
  private int mySessionID;
  private int myCaseID;
  private String myConversationID;

  /**
   * Constructs an instance of GWCase
   * 
   * @param aid the AID of an agent
   * @param cID the case ID of a Case
   */
  public GWCase(AID aid, int cID, String convID) {
    super();
    myAID = aid;
    myCaseID = cID;
    myConversationID = convID;
  }

  /**
   * @return the myAID
   */
  public AID getAID() {
    return myAID;
  }

  /**
   * @return the myCaseID
   */
  public int getCaseID() {
    return myCaseID;
  }

  /**
   * 
   * @return the myConversationID
   */
  public String getConversationID(){
    return myConversationID;
  }

}//class