package kripos.geo;

import java.util.Date;

import com.bbn.openmap.LatLonPoint;

/**
 * Contains information about a single Landmark, 
 * relative to the position of the owner of this instance.
 * 
 * @author oysteine
 * @version 1.0
 */
public class Landmark {
  private String myName;
  private LatLonPoint geoPosition; //TODO
  private double myDistance;
  private String myIP;
  private Date lastChecked;
  private double minRTT = 0;
  private double avgRTT;
  private double C1;
  private double epsilon;
  private String hashedTimestamp; //TODO

  /**
   * 
   */
  public Landmark(String IP) { 
    myIP = IP;
  }

  /**
   * 
   */
  public Landmark(String name, LatLonPoint llp, String IP) {
    myName = name;
    myIP = IP;
    geoPosition = llp;
  }

  /**
   * 
   */
  public Landmark(String name, double distance, String IP) {
    myName = name;
    myDistance = distance;
    myIP = IP;
  }

  /**
   * @return the geoPosition
   */
  public LatLonPoint getGeoPosition() {
    return geoPosition;
  }

  /**
   * @param myDistance the myDistance to set
   */
  public void setDistance(double myDistance) {
    this.myDistance = myDistance;
  }

  /**
   * @return the avgRTT
   */
  public double getAvgRTT() {
    return avgRTT;
  }

  /**
   * @param avgRTT the avgRTT to set
   */
  public void setAvgRTT(double avgRTT) {
    this.avgRTT = avgRTT;
  }

  /**
   * @return the c1
   */
  public double getC1() {
    return C1;
  }

  /**
   * @param c1 the c1 to set
   */
  public void setC1(double c1) {
    C1 = c1;
  }

  /**
   * @return the epsilon
   */
  public double getEpsilon() {
    return epsilon;
  }

  /**
   * @param epsilon the epsilon to set
   */
  public void setEpsilon(double epsilon) {
    this.epsilon = epsilon;
  }

  /**
   * @return the hashedTimestamp
   */
  public String getHashedTimestamp() {
    return hashedTimestamp;
  }

  /**
   * @param hashedTimestamp the hashedTimestamp to set
   */
  public void setHashedTimestamp(String hashedTimestamp) {
    this.hashedTimestamp = hashedTimestamp;
  }

  /**
   * @return the lastChecked
   */
  public Date getLastChecked() {
    return lastChecked;
  }

  /**
   * @param lastChecked the lastChecked to set
   */
  public void setLastChecked(Date lastChecked) {
    this.lastChecked = lastChecked;
  }

  /**
   * @return the minRTT
   */
  public double getMinRTT() {
    return minRTT;
  }

  /**
   * @param minRTT the minRTT to set
   */
  public void setMinRTT(double minRTT) {
    this.minRTT = minRTT;
  }

  /**
   * @return the distance
   */
  public double getDistance() {
    return myDistance;
  }

  /**
   * @param distance the distance to set
   */
  public void SetDistance(double distance) {
    myDistance = distance;
  }

  /**
   * @return the ip
   */
  public String getIP() {
    return myIP;
  }

  /**
   * @return the name
   */
  public String getName() {
    return myName;
  }

}//class