package kripos.geo;

import jade.core.behaviours.ParallelBehaviour;
import jade.core.behaviours.SequentialBehaviour;
import jade.core.behaviours.ThreadedBehaviourFactory;

/**
 * Wrapper for multiple PingBehaves running in dedicated threads
 * 
 * @author oysteine
 *
 */
public class WorkerTraceLandmarks extends ParallelBehaviour {
  private static final long serialVersionUID = -2880427229534140463L;
  private ThreadedBehaviourFactory myTbf;
  private Landmark myTarget;
  private WorkerAgent myWorkerAgent;

  public WorkerTraceLandmarks(WorkerAgent a, Landmark toTrace) {
    super(a, ParallelBehaviour.WHEN_ALL);
    myTbf = new ThreadedBehaviourFactory();
    myTarget = toTrace;
    myWorkerAgent = a;
  }

  /**
   * 
   * @return the <code>ThreadedBehaviourFactory</code> of this instance
   */
  public ThreadedBehaviourFactory getTbf(){
    return myTbf;
  }

  @Override
  public int onEnd(){
    ((SequentialBehaviour)root()).addSubBehaviour(new WorkerTraceCalculate(myWorkerAgent, myTarget));
    return 0;
  }

}//class
