package kripos.geo.ping;

public class PingItem {
  public final static int FILTERED=-2;
  public final static int LOST=-1;
  public final static int NORMAL_RTT=0;
  public final static int MIN_RTT=1;//not needed
  public final static int MAX_RTT=2;//not needed
  public final static int AVG_RTT=3;//not needed
  public final static int MED_RTT=4;//not needed
  private final int type;
  private final int sequence;
  private final float rtt;

  /**
   * 
   * @param newType
   * @param seqnr
   * @param rtt
   */
  public PingItem(int newType, int seqnr, float rtt){
    type = newType;
    sequence = seqnr;
    this.rtt = rtt;
  }

  /*
   * Getter methods
   */

  /**
   * The type indicates if this PingItem represents 
   * real ping information or a lost packet
   * 
   * @return the type of this PingItem
   */
  public int getType(){
    return type;
  }

  /**
   * The sequence number only has local meaning.
   * 
   * @return the sequence number of this PingItem
   */
  public int getSequence(){
    return sequence;		
  }

  /**
   * 
   * @return the RTT of this PingItem
   */
  public float getRTT(){
    return rtt;
  }

}//class