//legacy code. only works in 2D. originally meant used with a flat map based on UTM coordinates
//turned out to be not accurate enough when spanning multipe UTM zones

//only used for setting zoom level in current implementation

package kripos.math.circle;

import java.awt.geom.Point2D;
import java.io.ByteArrayOutputStream;
import java.io.PrintStream;
import java.util.Locale;

/**
 * Representing one intersection between two circles.
 * 
 * @author oysteine
 */
public class Intersection {
  /** Where the two circles cross. */
  public final Point2D point;
  final Circle c1;
  final Circle c2;


  /**
   * 
   * @param point    the intersection
   * @param circle1  one of the participating circles
   * @param circle2  the other participating circle
   */
  public Intersection(Point2D point, Circle circle1, Circle circle2) {
    this.point = point;
    this.c1 = circle1;
    this.c2 = circle2;
  }


  boolean isLeftOf(Intersection c) {
    return isLeftOf(c.point);
  }
  boolean isLeftOf(Point2D p) {
    return point.getX() < p.getX();
  }

  boolean isRightOf(Intersection c) {
    return isRightOf(c.point);
  }
  boolean isRightOf(Point2D p) {
    return point.getX() > p.getX();
  }

  boolean isAbove(Intersection c) {
    return isAbove(c.point);
  }
  boolean isAbove(Point2D p) {
    return point.getY() > p.getY();
  }

  boolean isBelow(Intersection c) {
    return isBelow(c.point);
  }
  boolean isBelow(Point2D p) {
    return point.getY() < p.getY();
  }


  /**
   * @param c target: an intersection above this
   * @return the angle between the x axis and the line from
   *          this intersection's point to <code>c</code>'s point 
   */
  double getAngle(Intersection c) {
    assert !isAbove(c);
    double opposite = c.point.getY() - point.getY(); // opposite
    double hyp = point.distance(c.point);
    if (c.isRightOf(this)) {
      return Math.asin(opposite / hyp);
    } else {
      return Math.PI - Math.asin(opposite / hyp);
    }
  }


  /**
   * @param c
   * @return <code>true</code> iff <code>c</code> is one of the circles in this intersection
   */
  public boolean belongsTo(Circle c) {
    return c == c1 || c == c2;
  }


  /**
   * @param c
   * @return the circle that is not <code>c</code>
   */
  Circle getOtherCircle(Circle c) {
    assert c == c1 || c == c2;
    return c == c1 ? c2 : c1;
  }


  @Override
  public String toString() {
    ByteArrayOutputStream tmp = new ByteArrayOutputStream();
    PrintStream stream = new PrintStream(tmp);
    stream.printf(Locale.US, "p(x=%.2f, y=%.2f), %s, %s",
        point.getX(), point.getY(), c1.toString(), c2.toString());
    return tmp.toString();
  }

}//class
