package kripos.math.servlet;



import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

/**
 * Display a page where an IP to trace can be enter.
 * Display a map with trace information if an IP has been entered.
 * 
 * @author oysteine
 */
public class GetTrace extends HttpServlet {

  private static final long serialVersionUID = 6720480250134837969L;


  @Override
  public void doGet(HttpServletRequest request, HttpServletResponse response)
  throws IOException, ServletException
  {
    String ip = request.getParameter("ip");

    response.setContentType("text/html");
    PrintWriter out = response.getWriter();
    out.println("<html>");
    out.println("<head>");
    out.println("<title>Trace IP</title>");
    out.println("</head>");
    out.println("<body>");

    out.println("<h3>Perform tracing</h3>");
    out.println("<form action=\"Map\" method=POST>");
    out.println("IP:");
    out.print("<input type=text size=20 name=ip");
    if (ip != null) {
      out.print(" value=\"" + ip + "\"");
    }
    out.println(">");
    out.println("<br>");
    out.println("<input type=submit name=action value=\"Get trace\"> ");
    out.println("<input type=submit name=action value=\"Force trace\">");
    out.println("</form>");

    out.println("</body>");
    out.println("</html>");
  }

  @Override
  public void doPost(HttpServletRequest request, HttpServletResponse response)
  throws IOException, ServletException
  {
    doGet(request, response);
  }
}
