package kripos.math.servlet;


import java.util.Date;
import java.util.List;

import kripos.math.circle.Circle;

class TraceCacheEntry {

  /** Address that was traced. */
  final String destination;
  /** Result of trace. */
  final List<Circle> circles;
  /** Time trace was started. */
  final Date start;
  /** Milliseconds used to perform the trace. */
  final long runTime;

  /** Last time this cache entry was used. */
  Date lastAccess;

  /**
   * Internal {@link TraceCache} cache id.
   * Set before added to the cache.
   */
  long cacheId = -1;

  /**
   * You must set {@link #cacheId} before inserting this entry to cache 
   * 
   * @param destination
   * @param circles
   */
  TraceCacheEntry(
      String destination, List<Circle> circles,
      Date start, long runTime) {
    this.destination = destination;
    this.circles = circles;
    this.start = start;
    this.runTime = runTime;

    this.lastAccess = new Date();
  }

}
